---
product: "AG Studio"
title: "Sharing & Caching Data"
description: "Share AG Studio's built-in data engine across instances, or cache it across a Studio instance's lifecycle."
framework: javascript
version: "3.0.0"
related:
    - title: "Data Overview"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/data/"
    - title: "Data Modelling"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-modelling/"
    - title: "Loading Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/loading-data/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Sharing & Caching Data

A Data Engine loads, processes, and caches data for Studio widgets.

Studio creates one automatically when you pass data sources via the `data` property, but you can create the built-in engine yourself to share it across instances, or cache it across a Studio instance's lifecycle.

## Built-in Engine

When you pass data sources directly to Studio, it creates a built-in Data Engine behind the scenes. Creating the engine externally with `createDataEngine(data)` gives you two benefits:

- **Sharing** - multiple Studio instances can point at the same engine, so they share a single copy of the data.
- **Caching across lifecycles** - the engine survives when Studio is destroyed and recreated, so data doesn't need to be re-fetched or reprocessed on remount.

#### Data Engine

```ts
import {
  AgDataEngine,
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createDataEngine,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "1": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "medals.country" },
              { id: "medals.sport" },
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
              { id: "medals.total", aggregation: "sum" },
            ],
          },
        },
        "2": {
          type: "column-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
        },
      },
      widgetLayout: {
        "1": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "2": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    edit: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

let dataEngine: AgDataEngine;

let created = true;

function recreate() {
  const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
  if (created) {
    studioApi.destroy();
    const placeholder = document.createElement("div");
    placeholder.textContent = "No current Studio instance";
    studioDiv.appendChild(placeholder);
  } else {
    studioDiv.firstElementChild?.remove();
    studioApi = createStudio(studioDiv, {
      ...studioProperties,
      data: dataEngine,
    });
  }
  document.getElementById("recreate")!.textContent = created
    ? "Recreate with Data Engine"
    : "Destroy Studio Instance";
  created = !created;
}

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    dataEngine = createDataEngine({ sources: [{ id: "medals", data }] });
    studioApi!.setProperty("data", dataEngine);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).recreate = recreate;
}
```

[Live example: Data Engine](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/data-engine/typescript/)

```ts
const dataEngine = createDataEngine({
    sources: [{
        id: 'medals',
        data: [
            {
                year: 2000,
                sport: 'Swimming',
                country: 'United States',
                // ... other fields
            },
            // ... other rows
        ],
    }],
});
```

```js
const studioProperties = {
    data: dataEngine,

    // other studio properties ...
}
```

See [Loading Data](https://www.ag-grid.com/studio/archive/3.0.0/javascript/loading-data/) for the full range of data loading patterns.

`createDataEngine(data)` accepts a `data` object of type `AgDataSourcesDefinition`.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| `sources` | `AgDataSource<TRegistry>[]` |  | One or more data sources. |
| `relationships` | `AgRelationDefinition[]` |  | When using multiple related tables, this describes the fields that link the tables together. |
| `expressions` | `AgExpressionFieldDefinition<TRegistry, AgFormat<TRegistry>, any>[]` |  | Expression field definitions for calculated columns. |
| `formats` | `TRegistry["formats"]` |  | Overrides to existing formats, or additional custom formats. |
| `description` | `string` |  | AI-facing overview of the entire dataset: what it contains, what it's for, domain quirks. |
| `calendars` | `AgCalendar[]` |  | Named time dimensions (calendars) that supply date fragments and a continuous date spine. |
| `buckets` | `TRegistry["buckets"]` |  | Additional date-fragment bucket definitions to register alongside the built-in set (year, quarter, month, week, day, monthOfYear, dayOfWeek, …). Use this to add project-specific groupings such as `weekend`, `dayOfMonth`, or `hour` that the built-in registry does not include. Provide via createBuckets so type-level registry inference works correctly. |
| `options` | `AgDataSourcesOptions` |  | Engine-wide behavioural options, such as fan-out detection policy. |

## Embedding Single Widgets

A widget cannot be used on its own outside of Studio. To place an individual widget in your own application, run a Studio instance that shows a single widget filling the canvas, with the panels hidden. Several such instances can share one engine, so the data is loaded once.

#### Single Widgets

```ts
import {
  AgDataEngine,
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  AgWidgetState,
  createDataEngine,
  createStudio,
  enableStudioDevValidations,
  studioTheme,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

// A single full-canvas widget, no panels - a Studio instance acting as one embeddable widget.
function singleWidgetState(id: string, widget: AgWidgetState): AgReportState {
  return {
    pages: [
      {
        id: "page1",
        widgets: { [id]: widget },
        widgetLayout: { [id]: { xTrack: 0, yTrack: 0, xSpan: 1, ySpan: 1 } },
      },
    ],
    selectedPageId: "page1",
  };
}

const gridState = singleWidgetState("1", {
  type: "grid",
  dataMapping: {
    cols: [
      { id: "medals.country" },
      { id: "medals.gold", aggregation: "sum" },
      { id: "medals.silver", aggregation: "sum" },
      { id: "medals.bronze", aggregation: "sum" },
    ],
  },
});

const chartState = singleWidgetState("2", {
  type: "column-chart-grouped",
  dataMapping: {
    categoryKey: [{ id: "medals.country" }],
    valueKey: [
      { id: "medals.gold", aggregation: "sum" },
      { id: "medals.silver", aggregation: "sum" },
      { id: "medals.bronze", aggregation: "sum" },
    ],
    tooltipKey: [],
  },
});

// Remove the spacing around the canvas so the widget fills its instance edge to edge.
const theme = studioTheme.withParams({ studioWrapperSpacing: 0 });

// View mode, no panels, a single-cell layout - one widget filling the whole canvas.
const baseProperties: AgStudioProperties = {
  mode: "view",
  panels: {},
  layout: {
    minWidth: 300,
    height: 300,
    columns: 1,
    rowHeight: 300,
    pagePadding: 0,
    widgetPadding: 0,
  },
  theme,
};

let gridApi: AgStudioApi;
let chartApi: AgStudioApi;
let dataEngine: AgDataEngine;

gridApi = createStudio(document.querySelector<HTMLElement>("#myStudio1")!, {
  ...baseProperties,
  initialState: gridState,
});
chartApi = createStudio(document.querySelector<HTMLElement>("#myStudio2")!, {
  ...baseProperties,
  initialState: chartState,
});

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    // One engine, shared by both instances - the data is loaded and cached once.
    dataEngine = createDataEngine({ sources: [{ id: "medals", data }] });
    gridApi.setProperty("data", dataEngine);
    chartApi.setProperty("data", dataEngine);
  });
```

[Live example: Single Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/single-widgets/typescript/)

To show a single widget, give the report a one-cell layout and hide the panels:

```js
const studioProperties = {
    mode: 'view',
    panels: {},
    layout: { columns: 1, height: 300, rowHeight: 300, pagePadding: 0, widgetPadding: 0 },

    // other studio properties ...
}
```

Each instance is independent. Panels belong to a single instance, so one panel cannot control several instances. Only the data engine is shared.

## Custom Engines

Sharing and caching, as described above, are features of the built-in engine only. For larger datasets, or when you want to replace query execution with a backend you already own, see the [Custom Engine](https://www.ag-grid.com/studio/archive/3.0.0/javascript/server-side-data/) guide in the Server-Side Data section.


---
product: "AG Studio"
title: "Sharing & Caching Data"
description: "Share AG Studio's built-in data engine across instances, or cache it across a Studio instance's lifecycle."
framework: angular
version: "3.0.0"
related:
    - title: "Data Overview"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/data/"
    - title: "Data Modelling"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/data-modelling/"
    - title: "Loading Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/loading-data/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Sharing & Caching Data

A Data Engine loads, processes, and caches data for Studio widgets.

Studio creates one automatically when you pass data sources via the `data` property, but you can create the built-in engine yourself to share it across instances, or cache it across a Studio instance's lifecycle.

## Built-in Engine

When you pass data sources directly to Studio, it creates a built-in Data Engine behind the scenes. Creating the engine externally with `createDataEngine(data)` gives you two benefits:

- **Sharing** - multiple Studio instances can point at the same engine, so they share a single copy of the data.
- **Caching across lifecycles** - the engine survives when Studio is destroyed and recreated, so data doesn't need to be re-fetched or reprocessed on remount.

#### Data Engine

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Data Engine](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/data-engine/angular/)

```ts
const dataEngine = createDataEngine({
    sources: [{
        id: 'medals',
        data: [
            {
                year: 2000,
                sport: 'Swimming',
                country: 'United States',
                // ... other fields
            },
            // ... other rows
        ],
    }],
});
```

```ts
<ag-studio
    [data]="data"
    /* other studio properties ... */ />

this.data = dataEngine;
```

See [Loading Data](https://www.ag-grid.com/studio/archive/3.0.0/angular/loading-data/) for the full range of data loading patterns.

`createDataEngine(data)` accepts a `data` object of type `AgDataSourcesDefinition`.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| `sources` | `AgDataSource<TRegistry>[]` |  | One or more data sources. |
| `relationships` | `AgRelationDefinition[]` |  | When using multiple related tables, this describes the fields that link the tables together. |
| `expressions` | `AgExpressionFieldDefinition<TRegistry, AgFormat<TRegistry>, any>[]` |  | Expression field definitions for calculated columns. |
| `formats` | `TRegistry["formats"]` |  | Overrides to existing formats, or additional custom formats. |
| `description` | `string` |  | AI-facing overview of the entire dataset: what it contains, what it's for, domain quirks. |
| `calendars` | `AgCalendar[]` |  | Named time dimensions (calendars) that supply date fragments and a continuous date spine. |
| `buckets` | `TRegistry["buckets"]` |  | Additional date-fragment bucket definitions to register alongside the built-in set (year, quarter, month, week, day, monthOfYear, dayOfWeek, …). Use this to add project-specific groupings such as `weekend`, `dayOfMonth`, or `hour` that the built-in registry does not include. Provide via createBuckets so type-level registry inference works correctly. |
| `options` | `AgDataSourcesOptions` |  | Engine-wide behavioural options, such as fan-out detection policy. |

## Embedding Single Widgets

A widget cannot be used on its own outside of Studio. To place an individual widget in your own application, run a Studio instance that shows a single widget filling the canvas, with the panels hidden. Several such instances can share one engine, so the data is loaded once.

#### Single Widgets

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Single Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/single-widgets/angular/)

To show a single widget, give the report a one-cell layout and hide the panels:

```ts
<ag-studio
    [mode]="mode"
    [panels]="panels"
    [layout]="layout"
    /* other studio properties ... */ />

this.mode = 'view';
this.panels = {};
this.layout = { columns: 1, height: 300, rowHeight: 300, pagePadding: 0, widgetPadding: 0 };
```

Each instance is independent. Panels belong to a single instance, so one panel cannot control several instances. Only the data engine is shared.

## Custom Engines

Sharing and caching, as described above, are features of the built-in engine only. For larger datasets, or when you want to replace query execution with a backend you already own, see the [Custom Engine](https://www.ag-grid.com/studio/archive/3.0.0/angular/server-side-data/) guide in the Server-Side Data section.


---
product: "AG Studio"
title: "Sharing & Caching Data"
description: "Share AG Studio's built-in data engine across instances, or cache it across a Studio instance's lifecycle."
framework: react
version: "3.0.0"
related:
    - title: "Data Overview"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/data/"
    - title: "Data Modelling"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/data-modelling/"
    - title: "Loading Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/loading-data/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Sharing & Caching Data

A Data Engine loads, processes, and caches data for Studio widgets.

Studio creates one automatically when you pass data sources via the `data` property, but you can create the built-in engine yourself to share it across instances, or cache it across a Studio instance's lifecycle.

## Built-in Engine

When you pass data sources directly to Studio, it creates a built-in Data Engine behind the scenes. Creating the engine externally with `createDataEngine(data)` gives you two benefits:

- **Sharing** - multiple Studio instances can point at the same engine, so they share a single copy of the data.
- **Caching across lifecycles** - the engine survives when Studio is destroyed and recreated, so data doesn't need to be re-fetched or reprocessed on remount.

#### Data Engine

```tsx
"use client";

import type {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
} from "ag-studio";
import { createDataEngine, enableStudioDevValidations } from "ag-studio";
import type { AgStudioRef } from "ag-studio-react";
import { AgStudio } from "ag-studio-react";
import React, {
  StrictMode,
  useCallback,
  useEffect,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const studioRef = useRef<AgStudioRef>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const [created, setCreated] = useState<boolean>(true);
  const initialState = useMemo<AgReportState>(
    () => ({
      pages: [
        {
          id: "page1",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "medals.country" },
                  { id: "medals.sport" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                  { id: "medals.total", aggregation: "sum" },
                ],
              },
            },
            "2": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "2": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    }),
    [],
  );

  useEffect(() => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) =>
        setData(createDataEngine({ sources: [{ id: "medals", data }] })),
      );
  }, []);

  const recreate = useCallback(() => {
    setCreated((currentCreated) => !currentCreated);
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <div className="example-controls">
          <div className="controls-row">
            <button onClick={recreate}>
              {created
                ? "Destroy Studio Instance"
                : "Recreate with Data Engine"}
            </button>
          </div>
        </div>

        {created && (
          <AgStudio
            ref={studioRef}
            style={studioStyle}
            className="my-studio-container"
            data={data}
            initialState={initialState}
            mode={"edit"}
          />
        )}
        {!created && (
          <div className="my-studio-container">No current Studio instance</div>
        )}
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Data Engine](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/data-engine/reactFunctionalTs/)

```ts
const dataEngine = createDataEngine({
    sources: [{
        id: 'medals',
        data: [
            {
                year: 2000,
                sport: 'Swimming',
                country: 'United States',
                // ... other fields
            },
            // ... other rows
        ],
    }],
});
```

```jsx
const data = useMemo(() => { 
	return dataEngine;
}, []);

<AgStudio data={data} />
```

See [Loading Data](https://www.ag-grid.com/studio/archive/3.0.0/react/loading-data/) for the full range of data loading patterns.

`createDataEngine(data)` accepts a `data` object of type `AgDataSourcesDefinition`.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| `sources` | `AgDataSource<TRegistry>[]` |  | One or more data sources. |
| `relationships` | `AgRelationDefinition[]` |  | When using multiple related tables, this describes the fields that link the tables together. |
| `expressions` | `AgExpressionFieldDefinition<TRegistry, AgFormat<TRegistry>, any>[]` |  | Expression field definitions for calculated columns. |
| `formats` | `TRegistry["formats"]` |  | Overrides to existing formats, or additional custom formats. |
| `description` | `string` |  | AI-facing overview of the entire dataset: what it contains, what it's for, domain quirks. |
| `calendars` | `AgCalendar[]` |  | Named time dimensions (calendars) that supply date fragments and a continuous date spine. |
| `buckets` | `TRegistry["buckets"]` |  | Additional date-fragment bucket definitions to register alongside the built-in set (year, quarter, month, week, day, monthOfYear, dayOfWeek, …). Use this to add project-specific groupings such as `weekend`, `dayOfMonth`, or `hour` that the built-in registry does not include. Provide via createBuckets so type-level registry inference works correctly. |
| `options` | `AgDataSourcesOptions` |  | Engine-wide behavioural options, such as fan-out detection policy. |

## Embedding Single Widgets

A widget cannot be used on its own outside of Studio. To place an individual widget in your own application, run a Studio instance that shows a single widget filling the canvas, with the panels hidden. Several such instances can share one engine, so the data is loaded once.

#### Single Widgets

```tsx
"use client";

import type { AgDataEngine, AgReportState, AgWidgetState } from "ag-studio";
import {
  createDataEngine,
  enableStudioDevValidations,
  studioTheme,
} from "ag-studio";
import { AgStudio } from "ag-studio-react";
import React, { StrictMode, useEffect, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

// A single full-canvas widget, no panels - a Studio instance acting as one embeddable widget.
function singleWidgetState(id: string, widget: AgWidgetState): AgReportState {
  return {
    pages: [
      {
        id: "page1",
        widgets: { [id]: widget },
        widgetLayout: { [id]: { xTrack: 0, yTrack: 0, xSpan: 1, ySpan: 1 } },
      },
    ],
    selectedPageId: "page1",
  };
}

const StudioExample = () => {
  const [dataEngine, setDataEngine] = useState<AgDataEngine>();

  // Remove the spacing around the canvas so the widget fills its instance edge to edge.
  const theme = useMemo(
    () => studioTheme.withParams({ studioWrapperSpacing: 0 }),
    [],
  );

  const gridState = useMemo<AgReportState>(
    () =>
      singleWidgetState("1", {
        type: "grid",
        dataMapping: {
          cols: [
            { id: "medals.country" },
            { id: "medals.gold", aggregation: "sum" },
            { id: "medals.silver", aggregation: "sum" },
            { id: "medals.bronze", aggregation: "sum" },
          ],
        },
      }),
    [],
  );

  const chartState = useMemo<AgReportState>(
    () =>
      singleWidgetState("2", {
        type: "column-chart-grouped",
        dataMapping: {
          categoryKey: [{ id: "medals.country" }],
          valueKey: [
            { id: "medals.gold", aggregation: "sum" },
            { id: "medals.silver", aggregation: "sum" },
            { id: "medals.bronze", aggregation: "sum" },
          ],
          tooltipKey: [],
        },
      }),
    [],
  );

  useEffect(() => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      // One engine, shared by both instances - the data is loaded and cached once.
      .then((data: any[]) =>
        setDataEngine(createDataEngine({ sources: [{ id: "medals", data }] })),
      );
  }, []);

  return (
    <div className="single-widgets">
      <AgStudio
        className="single-widget"
        mode="view"
        panels={{}}
        layout={{
          minWidth: 300,
          height: 300,
          columns: 1,
          rowHeight: 300,
          pagePadding: 0,
          widgetPadding: 0,
        }}
        theme={theme}
        initialState={gridState}
        data={dataEngine}
      />
      <div className="app-area">Your Application</div>
      <AgStudio
        className="single-widget"
        mode="view"
        panels={{}}
        layout={{
          minWidth: 300,
          height: 300,
          columns: 1,
          rowHeight: 300,
          pagePadding: 0,
          widgetPadding: 0,
        }}
        theme={theme}
        initialState={chartState}
        data={dataEngine}
      />
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Single Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/single-widgets/reactFunctionalTs/)

To show a single widget, give the report a one-cell layout and hide the panels:

```jsx
const [mode, setMode] = useState('view');
const panels = {};
const layout = { columns: 1, height: 300, rowHeight: 300, pagePadding: 0, widgetPadding: 0 };

<AgStudio
    mode={mode}
    panels={panels}
    layout={layout}
/>
```

Each instance is independent. Panels belong to a single instance, so one panel cannot control several instances. Only the data engine is shared.

## Custom Engines

Sharing and caching, as described above, are features of the built-in engine only. For larger datasets, or when you want to replace query execution with a backend you already own, see the [Custom Engine](https://www.ag-grid.com/studio/archive/3.0.0/react/server-side-data/) guide in the Server-Side Data section.


---
product: "AG Studio"
title: "Sharing & Caching Data"
description: "Share AG Studio's built-in data engine across instances, or cache it across a Studio instance's lifecycle."
framework: vue
version: "3.0.0"
related:
    - title: "Data Overview"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/data/"
    - title: "Data Modelling"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/data-modelling/"
    - title: "Loading Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/loading-data/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Sharing & Caching Data

A Data Engine loads, processes, and caches data for Studio widgets.

Studio creates one automatically when you pass data sources via the `data` property, but you can create the built-in engine yourself to share it across instances, or cache it across a Studio instance's lifecycle.

## Built-in Engine

When you pass data sources directly to Studio, it creates a built-in Data Engine behind the scenes. Creating the engine externally with `createDataEngine(data)` gives you two benefits:

- **Sharing** - multiple Studio instances can point at the same engine, so they share a single copy of the data.
- **Caching across lifecycles** - the engine survives when Studio is destroyed and recreated, so data doesn't need to be re-fetched or reprocessed on remount.

#### Data Engine

```ts
import type {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
} from "ag-studio";
import { createDataEngine, enableStudioDevValidations } from "ag-studio";
import { AgStudio } from "ag-studio-vue3";
import { createApp, defineComponent, onMounted, ref, shallowRef } from "vue";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
            <div style="display: flex; flex-direction: column; height: 100%">
                <div class="example-controls">
                    <div class="controls-row">
                        <button v-on:click="recreate()">{{ created ? 'Destroy Studio Instance' : 'Recreate with Data Engine' }}</button>
                    </div>
                </div>
                <ag-studio
                    v-if="created"
                    style="width: 100%; height: 100%;"
                    class="my-studio-container"
                    :initialState="initialState"
                    :mode="'edit'"
                    :data="data"></ag-studio>
                <div class="my-studio-container" v-if="!created">No current Studio instance</div>
            </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "medals.country" },
                  { id: "medals.sport" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                  { id: "medals.total", aggregation: "sum" },
                ],
              },
            },
            "2": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "2": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    });
    const created = ref<boolean>(true);
    const data = shallowRef<AgDataSourcesDefinition | AgDataEngine>(null);

    onMounted(() => {
      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then(
          (respData) =>
            (data.value = createDataEngine({
              sources: [{ id: "medals", data: respData }],
            })),
        );
    });

    const recreate = () => {
      created.value = !created.value;
    };

    return {
      initialState,
      created,
      data,
      recreate,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Data Engine](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/data-engine/vue3/)

```ts
const dataEngine = createDataEngine({
    sources: [{
        id: 'medals',
        data: [
            {
                year: 2000,
                sport: 'Swimming',
                country: 'United States',
                // ... other fields
            },
            // ... other rows
        ],
    }],
});
```

```ts
<ag-studio
    :data="data"
    /* other studio properties ... */>
</ag-studio>

this.data = dataEngine;
```

See [Loading Data](https://www.ag-grid.com/studio/archive/3.0.0/vue/loading-data/) for the full range of data loading patterns.

`createDataEngine(data)` accepts a `data` object of type `AgDataSourcesDefinition`.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| `sources` | `AgDataSource<TRegistry>[]` |  | One or more data sources. |
| `relationships` | `AgRelationDefinition[]` |  | When using multiple related tables, this describes the fields that link the tables together. |
| `expressions` | `AgExpressionFieldDefinition<TRegistry, AgFormat<TRegistry>, any>[]` |  | Expression field definitions for calculated columns. |
| `formats` | `TRegistry["formats"]` |  | Overrides to existing formats, or additional custom formats. |
| `description` | `string` |  | AI-facing overview of the entire dataset: what it contains, what it's for, domain quirks. |
| `calendars` | `AgCalendar[]` |  | Named time dimensions (calendars) that supply date fragments and a continuous date spine. |
| `buckets` | `TRegistry["buckets"]` |  | Additional date-fragment bucket definitions to register alongside the built-in set (year, quarter, month, week, day, monthOfYear, dayOfWeek, …). Use this to add project-specific groupings such as `weekend`, `dayOfMonth`, or `hour` that the built-in registry does not include. Provide via createBuckets so type-level registry inference works correctly. |
| `options` | `AgDataSourcesOptions` |  | Engine-wide behavioural options, such as fan-out detection policy. |

## Embedding Single Widgets

A widget cannot be used on its own outside of Studio. To place an individual widget in your own application, run a Studio instance that shows a single widget filling the canvas, with the panels hidden. Several such instances can share one engine, so the data is loaded once.

#### Single Widgets

```ts
import type { AgDataEngine, AgReportState, AgWidgetState } from "ag-studio";
import {
  createDataEngine,
  enableStudioDevValidations,
  studioTheme,
} from "ag-studio";
import { AgStudio } from "ag-studio-vue3";
import { createApp, defineComponent, onMounted, ref, shallowRef } from "vue";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

// A single full-canvas widget, no panels - a Studio instance acting as one embeddable widget.
function singleWidgetState(id: string, widget: AgWidgetState): AgReportState {
  return {
    pages: [
      {
        id: "page1",
        widgets: { [id]: widget },
        widgetLayout: { [id]: { xTrack: 0, yTrack: 0, xSpan: 1, ySpan: 1 } },
      },
    ],
    selectedPageId: "page1",
  };
}

const VueExample = defineComponent({
  template: `
        <div class="single-widgets">
            <ag-studio
                class="single-widget"
                :mode="'view'"
                :panels="{}"
                :layout="layout"
                :theme="theme"
                :initialState="gridState"
                :data="data"></ag-studio>
            <div class="app-area">Your Application</div>
            <ag-studio
                class="single-widget"
                :mode="'view'"
                :panels="{}"
                :layout="layout"
                :theme="theme"
                :initialState="chartState"
                :data="data"></ag-studio>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup() {
    // Remove the spacing around the canvas so the widget fills its instance edge to edge.
    const theme = studioTheme.withParams({ studioWrapperSpacing: 0 });
    const layout = {
      minWidth: 300,
      height: 300,
      columns: 1,
      rowHeight: 300,
      pagePadding: 0,
      widgetPadding: 0,
    };

    const gridState = ref<AgReportState>(
      singleWidgetState("1", {
        type: "grid",
        dataMapping: {
          cols: [
            { id: "medals.country" },
            { id: "medals.gold", aggregation: "sum" },
            { id: "medals.silver", aggregation: "sum" },
            { id: "medals.bronze", aggregation: "sum" },
          ],
        },
      }),
    );

    const chartState = ref<AgReportState>(
      singleWidgetState("2", {
        type: "column-chart-grouped",
        dataMapping: {
          categoryKey: [{ id: "medals.country" }],
          valueKey: [
            { id: "medals.gold", aggregation: "sum" },
            { id: "medals.silver", aggregation: "sum" },
            { id: "medals.bronze", aggregation: "sum" },
          ],
          tooltipKey: [],
        },
      }),
    );

    const data = shallowRef<AgDataEngine>();

    onMounted(() => {
      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        // One engine, shared by both instances - the data is loaded and cached once.
        .then(
          (respData) =>
            (data.value = createDataEngine({
              sources: [{ id: "medals", data: respData }],
            })),
        );
    });

    return { theme, layout, gridState, chartState, data };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Single Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/sharing-caching-data/single-widgets/vue3/)

To show a single widget, give the report a one-cell layout and hide the panels:

```ts
<ag-studio
    :mode="mode"
    :panels="panels"
    :layout="layout"
    /* other studio properties ... */>
</ag-studio>

this.mode = 'view';
this.panels = {};
this.layout = { columns: 1, height: 300, rowHeight: 300, pagePadding: 0, widgetPadding: 0 };
```

Each instance is independent. Panels belong to a single instance, so one panel cannot control several instances. Only the data engine is shared.

## Custom Engines

Sharing and caching, as described above, are features of the built-in engine only. For larger datasets, or when you want to replace query execution with a backend you already own, see the [Custom Engine](https://www.ag-grid.com/studio/archive/3.0.0/vue/server-side-data/) guide in the Server-Side Data section.
